]> gitweb.factorcode.org Git - factor.git/blob - build.sh
linux-arm: Update build target.
[factor.git] / build.sh
1 #!/usr/bin/env bash
2
3 # Programs returning != 0 will not cause script to exit
4 set +e
5
6 # Case insensitive string comparison
7 shopt -s nocaseglob
8 #shopt -s nocasematch
9
10 ECHO=echo
11 OS=
12 ARCH=
13 WORD=
14 GIT_PROTOCOL=${GIT_PROTOCOL:="git"}
15 GIT_URL=${GIT_URL:=$GIT_PROTOCOL"://github.com/factor/factor.git"}
16 SCRIPT_ARGS="$*"
17
18 REQUIRE_CLANG_VERSION=3.1
19
20 # return 1 on found
21 test_program_installed() {
22     if ! [[ -n $(type -p $1) ]] ; then
23         return 0;
24     fi
25     return 1;
26 }
27
28 # return 1 on found
29 test_programs_installed() {
30     local installed=0;
31     $ECHO -n "Checking for all($*)..."
32     for i in "$@" ;
33     do
34         test_program_installed $i
35         if [[ $? -eq 1 ]]; then
36             installed=$(( $installed + 1 ))
37         fi
38     done
39     if [[ $installed -eq $# ]] ; then
40         $ECHO "found!"
41         return 1
42     else
43         $ECHO "all not found."
44         return 0
45     fi
46 }
47
48 exit_script() {
49     if [[ $FIND_MAKE_TARGET = true ]] ; then
50         # Must be echo not $ECHO
51         echo $MAKE_TARGET;
52     fi
53     exit $1
54 }
55
56 ensure_program_installed() {
57     local installed=0;
58     $ECHO -n "Checking for any($*)..."
59     for i in "$@" ;
60     do
61         test_program_installed $i
62         if [[ $? -eq 1 ]]; then
63             $ECHO "found $i!"
64             installed=$(( $installed + 1 ))
65             return
66         fi
67     done
68     $ECHO "none found."
69     $ECHO -n "Install "
70     if [[ $# -eq 1 ]] ; then
71         $ECHO -n $1
72     else
73         $ECHO -n "any of [ $* ]"
74     fi
75     $ECHO " and try again."
76     if [[ $OS == macosx ]] ; then
77         $ECHO "If you have Xcode 4.3 or higher installed, you must install the"
78         $ECHO "Command Line Tools from Xcode Preferences > Downloads in order"
79         $ECHO "to build Factor."
80     fi
81     exit_script 1;
82 }
83
84 check_ret() {
85     RET=$?
86     if [[ $RET -ne 0 ]] ; then
87        $ECHO $1 failed
88        exit_script 2
89     fi
90 }
91
92 set_downloader() {
93     test_program_installed wget
94     if [[ $? -ne 0 ]] ; then
95         DOWNLOADER="wget -nd"
96         DOWNLOADER_NAME=wget
97         return
98     fi
99     test_program_installed curl
100     if [[ $? -ne 0 ]] ; then
101         DOWNLOADER="curl -L -f -O"
102         DOWNLOADER_NAME=curl
103         return
104     fi
105     $ECHO "error: wget or curl required"
106     exit_script 11
107 }
108
109 set_md5sum() {
110     test_program_installed md5sum
111     if [[ $? -ne 0 ]] ; then
112         MD5SUM=md5sum
113     else
114         MD5SUM="md5 -r"
115     fi
116 }
117
118 semver_into() {
119     RE_SEMVER="^([0-9]*)\.([0-9]*)\.([0-9]*)-?(.*)?$" # 3.3.3-5
120     CLANG_RE_OLD="^([0-9]*)\.([0-9]*)-?(.*)?$" # 3.3-5
121     if [[ $1 =~ $RE_SEMVER ]] ; then
122         export "$2=${BASH_REMATCH[1]}"
123         export "$3=${BASH_REMATCH[2]}"
124         export "$4=${BASH_REMATCH[3]}"
125         export "$5=${BASH_REMATCH[4]}"
126     elif [[ $1 =~ $CLANG_RE_OLD ]] ; then
127         export "$2=${BASH_REMATCH[1]}"
128         export "$3=${BASH_REMATCH[2]}"
129         export "$4=0"
130         export "$5=${BASH_REMATCH[3]}"
131     else
132         echo "unsupported version number, please report a bug: $1"
133         exit 123
134     fi
135 }
136
137 clang_version_ok() {
138     CLANG_VERSION=$(clang --version | head -n1)
139     CLANG_VERSION_RE='^[a-zA-Z0-9 ]* version (.*)$' # 3.3-5
140     if [[ $CLANG_VERSION =~ $CLANG_VERSION_RE ]] ; then
141         export "CLANG_VERSION=${BASH_REMATCH[1]}"
142         local CLANG_MAJOR CLANG_MINOR CLANG_PATCH CLANG_SPECIAL
143         semver_into "$CLANG_VERSION" CLANG_MAJOR CLANG_MINOR CLANG_PATCH CLANG_SPECIAL
144         if [[ $CLANG_MAJOR -lt 3
145             || ( $CLANG_MAJOR -eq 3 && $CLANG_MINOR -le 1 )
146             ]] ; then
147             echo "clang version required >= $REQUIRE_CLANG_VERSION, got $CLANG_VERSION"
148             return 1
149         fi
150     else
151         return 1
152     fi
153     return 0
154 }
155
156 set_cc() {
157     # on Cygwin we MUST use the MinGW "cross-compiler", therefore check these first
158     # furthermore, we prefer 64 bit over 32 bit versions if both are available
159
160     # we need this condition so we don't find a mingw32 compiler on linux
161     if [[ $OS == windows ]] ; then
162         test_programs_installed x86_64-w64-mingw32-gcc x86_64-w64-mingw32-g++
163         if [[ $? -ne 0 ]] ; then
164             [ -z "$CC" ] && CC=x86_64-w64-mingw32-gcc
165             [ -z "$CXX" ] && CXX=x86_64-w64-mingw32-g++
166             return
167         fi
168
169         test_programs_installed i686-w64-mingw32-gcc i686-w64-mingw32-g++
170         if [[ $? -ne 0 ]] ; then
171             [ -z "$CC" ] && CC=i686-w64-mingw32-gcc
172             [ -z "$CXX" ] && CXX=i686-w64-mingw32-g++
173             return
174         fi
175     fi
176
177     test_programs_installed clang clang++
178     if [[ $? -ne 0 ]] && clang_version_ok ; then
179         [ -z "$CC" ] && CC=clang
180         [ -z "$CXX" ] && CXX=clang++
181         return
182     fi
183
184     # gcc and g++ will fail to correctly build Factor on Cygwin
185     test_programs_installed gcc g++
186     if [[ $? -ne 0 ]] ; then
187         [ -z "$CC" ] && CC=gcc
188         [ -z "$CXX" ] && CXX=g++
189         return
190     fi
191
192     $ECHO "error: high enough version of either (clang/clang++) or (gcc/g++) required!"
193     exit_script 10
194 }
195
196 set_make() {
197     case $OS in
198         freebsd) MAKE=gmake ;;
199         *) MAKE=make ;;
200     esac
201     if [[ $MAKE = 'gmake' ]] ; then
202         ensure_program_installed gmake
203     fi
204 }
205
206 check_installed_programs() {
207     ensure_program_installed chmod
208     ensure_program_installed uname
209     ensure_program_installed git
210     ensure_program_installed wget curl
211     ensure_program_installed clang x86_64-w64-mingw32-gcc i686-w64-mingw32-gcc gcc
212     ensure_program_installed clang++ x86_64-w64-mingw32-g++ i686-w64-mingw32-g++ g++ cl
213     ensure_program_installed make gmake
214     ensure_program_installed md5sum md5
215     ensure_program_installed cut
216 }
217
218 check_library_exists() {
219     GCC_TEST=factor-library-test.c
220     GCC_OUT=factor-library-test.out
221     $ECHO -n "Checking for library $1..."
222     $ECHO "int main(){return 0;}" > $GCC_TEST
223     $CC $GCC_TEST -o $GCC_OUT -l $1 2>&-
224     if [[ $? -ne 0 ]] ; then
225         $ECHO "not found."
226     else
227         $ECHO "found."
228     fi
229     $DELETE -f $GCC_TEST
230     check_ret $DELETE
231     $DELETE -f $GCC_OUT
232     check_ret $DELETE
233 }
234
235 check_X11_libraries() {
236     check_library_exists GL
237     check_library_exists X11
238     check_library_exists pango-1.0
239 }
240
241 check_gtk_libraries() {
242     check_library_exists gobject-2.0
243     check_library_exists gtk-x11-2.0
244     check_library_exists gdk-x11-2.0
245     check_library_exists gdk_pixbuf-2.0
246     check_library_exists gtkglext-x11-1.0
247     check_library_exists atk-1.0
248     check_library_exists gio-2.0
249     check_library_exists gdkglext-x11-1.0
250     check_library_exists pango-1.0
251 }
252
253
254 check_libraries() {
255     case $OS in
256             linux) check_X11_libraries
257                    check_gtk_libraries;;
258             unix) check_gtk_libraries;;
259     esac
260 }
261
262 check_factor_exists() {
263     if [[ -d "factor" ]] ; then
264         $ECHO "A directory called 'factor' already exists."
265         $ECHO "Rename or delete it and try again."
266         exit_script 4
267     fi
268 }
269
270 find_os() {
271     if [[ -n $OS ]] ; then return; fi
272     $ECHO "Finding OS..."
273     local uname_s=$(uname -s)
274     check_ret uname
275     case $uname_s in
276         CYGWIN_NT-5.2-WOW64) OS=windows;;
277         *CYGWIN_NT*) OS=windows;;
278         *CYGWIN*) OS=windows;;
279         MINGW32*) OS=windows;;
280         MINGW64*) OS=windows;;
281         MSYS_NT*) OS=windows;;
282         *darwin*) OS=macosx;;
283         *Darwin*) OS=macosx;;
284         *linux*) OS=linux;;
285         *Linux*) OS=linux;;
286         FreeBSD) OS=freebsd;;
287         Haiku) OS=haiku;;
288     esac
289 }
290
291 find_architecture() {
292     if [[ -n $ARCH ]] ; then return; fi
293     $ECHO "Finding ARCH..."
294     uname_m=$(uname -m)
295     check_ret uname
296     case $uname_m in
297        i386) ARCH=x86;;
298        i686) ARCH=x86;;
299        i86pc) ARCH=x86;;
300        amd64) ARCH=x86;;
301        ppc64) ARCH=ppc;;
302        *86) ARCH=x86;;
303        *86_64) ARCH=x86;;
304        aarch64) ARCH=arm64;;
305        iPhone5*[3-9]) ARCH=arm64;;
306        iPhone[6-9]*) ARCH=arm64;;
307        iPhone[1-9][0-9]*) ARCH=arm64;;
308        iPad[4-9]*) ARCH=arm64;;
309        iPad[1-9][0-9]*) ARCH=arm64;;
310        AppleTV[5-9]*) ARCH=arm64;;
311        AppleTV[1-9][0-9]*) ARCH=arm64;;
312        "Power Macintosh") ARCH=ppc;;
313     esac
314 }
315
316 find_num_cores() {
317     $ECHO "Finding num cores..."
318     NUM_CORES=1
319     uname_s=$(uname -s)
320     check_ret uname
321     case $uname_s in
322         CYGWIN_NT-5.2-WOW64 | *CYGWIN_NT* | *CYGWIN* | MINGW32*) NUM_CORES=$NUMBER_OF_PROCESSORS;;
323         *linux* | *Linux*) NUM_CORES=$(getconf _NPROCESSORS_ONLN || nproc);;
324         *darwin* | *Darwin* | freebsd) NUM_CORES=$(sysctl -n hw.ncpu);;
325     esac
326 }
327
328 echo_test_program() {
329     #! Must be 'echo'
330     echo -e "int main(){ return (long)(8*sizeof(void*)); }"
331 }
332
333 c_find_word_size() {
334     $ECHO "Finding WORD..."
335     C_WORD="factor-word-size"
336     echo_test_program | $CC -o $C_WORD -xc -
337     check_ret $CC
338     ./$C_WORD
339     WORD_OUT=$?
340     case $WORD in
341         32) ;;
342         64) ;;
343         *)
344             echo "Word size should be 32/64, got $WORD"
345             exit_script 15;;
346     esac
347     $DELETE -f $C_WORD
348     echo "$WORD_OUT"
349 }
350
351 intel_macosx_word_size() {
352     ensure_program_installed sysctl
353     $ECHO -n "Testing if your Intel Mac supports 64bit binaries..."
354     sysctl machdep.cpu.extfeatures | grep EM64T >/dev/null
355     if [[ $? -eq 0 ]] ; then
356         WORD=64
357         $ECHO "yes!"
358     else
359         WORD=32
360         $ECHO "no."
361     fi
362 }
363
364 find_word_size() {
365     if [[ -n $WORD ]] ; then return; fi
366     if [[ $OS == macosx && $ARCH == x86 ]] ; then
367         intel_macosx_word_size
368     else
369         WORD=$(find_word_size_cpp || c_find_word_size)
370     fi
371 }
372
373 find_word_size_cpp() {
374     SIXTY_FOUR='defined(__aarch64__) || defined(__x86_64__) || defined(_M_AMD64) || defined(__PPC64__) || defined(__64BIT__)'
375     THIRTY_TWO='defined(i386) || defined(__i386) || defined(__i386__) || defined(_MIX86)'
376     cc -E -xc <(echo -e "#if ${SIXTY_FOUR}\n64\n#elif ${THIRTY_TWO}\n32\n#endif") | tail -1
377 }
378
379 set_factor_binary() {
380     case $OS in
381         windows) FACTOR_BINARY=factor.com;;
382         *) FACTOR_BINARY=factor;;
383     esac
384 }
385
386 set_factor_library() {
387     case $OS in
388         windows) FACTOR_LIBRARY=factor.dll;;
389         macosx) FACTOR_LIBRARY=libfactor.dylib;;
390         *) FACTOR_LIBRARY=libfactor.a;;
391     esac
392 }
393
394 set_factor_image() {
395     FACTOR_IMAGE=factor.image
396     FACTOR_IMAGE_FRESH=factor.image.fresh
397 }
398
399 echo_build_info() {
400     $ECHO OS=$OS
401     $ECHO ARCH=$ARCH
402     $ECHO NUM_CORES=$NUM_CORES
403     $ECHO WORD=$WORD
404     $ECHO DEBUG=$DEBUG
405     $ECHO REPRODUCIBLE=$REPRODUCIBLE
406     $ECHO CURRENT_BRANCH=$CURRENT_BRANCH
407     $ECHO FACTOR_BINARY=$FACTOR_BINARY
408     $ECHO FACTOR_LIBRARY=$FACTOR_LIBRARY
409     $ECHO FACTOR_IMAGE=$FACTOR_IMAGE
410     $ECHO MAKE_TARGET=$MAKE_TARGET
411     $ECHO BOOT_IMAGE=$BOOT_IMAGE
412     $ECHO MAKE_IMAGE_TARGET=$MAKE_IMAGE_TARGET
413     $ECHO GIT_PROTOCOL=$GIT_PROTOCOL
414     $ECHO GIT_URL=$GIT_URL
415     $ECHO DOWNLOADER=$DOWNLOADER
416     $ECHO CC=$CC
417     $ECHO CXX=$CXX
418     $ECHO MAKE=$MAKE
419     $ECHO COPY=$COPY
420     $ECHO DELETE=$DELETE
421 }
422
423 check_os_arch_word() {
424     if ! [[ -n $OS && -n $ARCH && -n $WORD ]] ; then
425         $ECHO "OS: $OS"
426         $ECHO "ARCH: $ARCH"
427         $ECHO "WORD: $WORD"
428         $ECHO "OS, ARCH, or WORD is empty.  Please report this."
429
430         $ECHO $MAKE_TARGET
431         exit_script 5
432     fi
433 }
434
435 set_build_info() {
436     check_os_arch_word
437     if [[ $OS == linux && $ARCH == ppc ]] ; then
438         MAKE_IMAGE_TARGET=linux-ppc.32
439         MAKE_TARGET=linux-ppc-32
440     elif [[ $OS == linux && $ARCH == arm64 ]] ; then
441         MAKE_IMAGE_TARGET=unix-arm.64
442         MAKE_TARGET=linux-arm-64
443     elif [[ $OS == windows && $ARCH == x86 && $WORD == 64 ]] ; then
444         MAKE_IMAGE_TARGET=windows-x86.64
445         MAKE_TARGET=windows-x86-64
446     elif [[ $OS == windows && $ARCH == x86 && $WORD == 32 ]] ; then
447         MAKE_IMAGE_TARGET=windows-x86.32
448         MAKE_TARGET=windows-x86-32
449     elif [[ $ARCH == x86 && $WORD == 64 ]] ; then
450         MAKE_IMAGE_TARGET=unix-x86.64
451         MAKE_TARGET=$OS-x86-64
452     elif [[ $ARCH == x86 && $WORD == 32 ]] ; then
453         MAKE_IMAGE_TARGET=unix-x86.32
454         MAKE_TARGET=$OS-x86-32
455     else
456         MAKE_IMAGE_TARGET=$ARCH.$WORD
457         MAKE_TARGET=$OS-$ARCH-$WORD
458     fi
459     BOOT_IMAGE=boot.$MAKE_IMAGE_TARGET.image
460 }
461
462 parse_build_info() {
463     ensure_program_installed cut
464     $ECHO "Parsing make target from command line: $1"
465     OS=$(echo $1 | cut -d '-' -f 1)
466     ARCH=$(echo $1 | cut -d '-' -f 2)
467     WORD=$(echo $1 | cut -d '-' -f 3)
468
469     if [[ $OS == linux && $ARCH == ppc ]] ; then WORD=32; fi
470     if [[ $OS == linux && $ARCH == arm ]] ; then WORD=32; fi
471     if [[ $OS == macosx && $ARCH == ppc ]] ; then WORD=32; fi
472
473     $ECHO "OS=$OS"
474     $ECHO "ARCH=$ARCH"
475     $ECHO "WORD=$WORD"
476 }
477
478 find_build_info() {
479     find_os
480     find_architecture
481     find_num_cores
482     set_cc
483     find_word_size
484     set_current_branch
485     set_factor_binary
486     set_factor_library
487     set_factor_image
488     set_build_info
489     set_downloader
490     set_make
491     echo_build_info
492 }
493
494 invoke_git() {
495     git "$@"
496     check_ret git
497 }
498
499 git_clone() {
500     $ECHO "Downloading the git repository from github.com..."
501     invoke_git clone $GIT_URL
502 }
503
504 update_script_name() {
505     $ECHO "$(dirname $0)/_update.sh"
506 }
507
508 update_script() {
509     local -r update_script=$(update_script_name)
510     local -r bash_path=$(which bash)
511     $ECHO "updating from ${CURRENT_BRANCH}"
512     $ECHO "#!$bash_path" >"$update_script"
513     $ECHO "git pull \"$GIT_URL\" ${CURRENT_BRANCH}" >>"$update_script"
514     $ECHO "if [[ \$? -eq 0 ]]; then exec \"$0\" $SCRIPT_ARGS; else echo \"git pull failed\"; exit 2; fi" \
515         >>"$update_script"
516     $ECHO "exit 0" >>"$update_script"
517
518     chmod 755 "$update_script"
519     exec "$update_script"
520 }
521
522 update_script_changed() {
523     invoke_git diff --stat "$(invoke_git merge-base HEAD FETCH_HEAD)" FETCH_HEAD | grep 'build\.sh' >/dev/null
524 }
525
526 git_fetch() {
527     $ECHO "Fetching the git repository from github.com..."
528     set_current_branch
529
530     rm -f "$(update_script_name)"
531     $ECHO git fetch "$GIT_URL" "${CURRENT_BRANCH}"
532     invoke_git fetch "$GIT_URL" "${CURRENT_BRANCH}"
533
534     if update_script_changed; then
535         $ECHO "Updating and restarting the build.sh script..."
536         update_script
537     else
538         $ECHO "Updating the working tree..."
539         invoke_git pull "$GIT_URL" "${CURRENT_BRANCH}"
540     fi
541 }
542
543 cd_factor() {
544     cd "factor"
545     check_ret cd
546 }
547
548 set_copy() {
549     case $OS in
550         windows) COPY=cp;;
551         *) COPY=cp;;
552     esac
553 }
554
555 set_delete() {
556     case $OS in
557         windows) DELETE=rm;;
558         *) DELETE=rm;;
559     esac
560 }
561
562 backup_factor() {
563     $ECHO "Backing up factor..."
564     $COPY $FACTOR_BINARY $FACTOR_BINARY.bak
565     $COPY $FACTOR_LIBRARY $FACTOR_LIBRARY.bak
566     $COPY $BOOT_IMAGE $BOOT_IMAGE.bak
567     $COPY $FACTOR_IMAGE $FACTOR_IMAGE.bak
568     $ECHO "Done with backup."
569 }
570
571 check_makefile_exists() {
572     if [[ ! -e "GNUmakefile" ]] ; then
573         $ECHO ""
574         $ECHO "***GNUmakefile not found***"
575         $ECHO "You are likely in the wrong directory."
576         $ECHO "Run this script from your factor directory:"
577         $ECHO "     ./build.sh"
578         exit_script 6
579     fi
580 }
581
582 invoke_make() {
583     check_makefile_exists
584     $MAKE $MAKE_OPTS "$@"
585     check_ret $MAKE
586 }
587
588 make_clean() {
589     invoke_make clean
590 }
591
592 make_factor() {
593     $ECHO "Building factor with $NUM_CORES cores"
594     invoke_make CC=$CC CXX=$CXX $MAKE_TARGET -j$NUM_CORES
595 }
596
597 make_clean_factor() {
598     make_clean
599     make_factor
600 }
601
602 current_git_branch() {
603     # git rev-parse --abbrev-ref HEAD # outputs HEAD for detached head
604     # outputs nothing for detached HEAD, which is fine for ``git fetch``
605     git describe --all --exact-match 2>/dev/null | sed 's=.*/=='
606 }
607
608 check_url() {
609     if [[ $DOWNLOADER_NAME == 'wget' ]]; then
610         if [[ $(wget -S --spider $1 2>&1 | grep 'HTTP/1.1 200 OK') ]]; then
611             return 0
612         else
613             return 1
614         fi
615     elif [[ $DOWNLOADER_NAME == 'curl' ]]; then
616         local code=$(curl -sL -w "%{http_code}\\n" "$1" -o /dev/null)
617         if [[ $code -eq 200 ]]; then return 0; else return 1; fi
618     else
619         $ECHO "error: wget or curl required in check_url"
620         exit_script 12
621     fi
622 }
623
624 # If we are on a branch, first try to get a boot image for that branch.
625 # Otherwise, just use `master`
626 set_boot_image_vars() {
627     set_current_branch
628     local url="http://downloads.factorcode.org/images/${CURRENT_BRANCH}/checksums.txt"
629     check_url $url
630     if [[ $? -eq 0 ]]; then
631         CHECKSUM_URL="$url"
632         BOOT_IMAGE_URL="http://downloads.factorcode.org/images/${CURRENT_BRANCH}/${BOOT_IMAGE}"
633     else
634         $ECHO "boot image for branch \`${CURRENT_BRANCH}\` is not on server, trying master instead"
635         $ECHO "  tried nonexistent url: ${url}"
636         CHECKSUM_URL="http://downloads.factorcode.org/images/master/checksums.txt"
637         BOOT_IMAGE_URL="http://downloads.factorcode.org/images/master/${BOOT_IMAGE}"
638     fi
639 }
640
641 set_current_branch() {
642     if [ -n "${CI_BRANCH}" ]; then
643         CURRENT_BRANCH="${CI_BRANCH}"
644     else
645         CURRENT_BRANCH=$(current_git_branch)
646     fi
647 }
648
649 update_boot_image() {
650     set_boot_image_vars
651     $ECHO "Deleting old images..."
652     $DELETE checksums.txt* > /dev/null 2>&1
653     # delete boot images with one or two characters after the dot
654     $DELETE $BOOT_IMAGE.{?,??} > /dev/null 2>&1
655     $DELETE temp/staging.*.image > /dev/null 2>&1
656     if [[ -f $BOOT_IMAGE ]] ; then
657         get_url $CHECKSUM_URL
658         local factorcode_md5=$(cat checksums.txt | grep $BOOT_IMAGE | cut -f2 -d' ')
659         set_md5sum
660         local disk_md5=$($MD5SUM $BOOT_IMAGE | cut -f1 -d' ')
661         $ECHO "Factorcode md5: $factorcode_md5";
662         $ECHO "Disk md5: $disk_md5";
663         if [[ "$factorcode_md5" == "$disk_md5" ]] ; then
664             $ECHO "Your disk boot image matches the one on downloads.factorcode.org."
665         else
666             $DELETE $BOOT_IMAGE > /dev/null 2>&1
667             get_boot_image
668         fi
669     else
670         get_boot_image
671     fi
672 }
673
674 get_boot_image() {
675     $ECHO "Downloading boot image $BOOT_IMAGE."
676     get_url "${BOOT_IMAGE_URL}"
677 }
678
679 get_url() {
680     if [[ -z $DOWNLOADER ]] ; then
681         set_downloader;
682     fi
683     $ECHO $DOWNLOADER $1 ;
684     $DOWNLOADER $1
685     check_ret $DOWNLOADER
686 }
687
688 get_config_info() {
689     find_build_info
690     check_installed_programs
691     check_libraries
692 }
693
694 copy_fresh_image() {
695     $ECHO "Copying $FACTOR_IMAGE to $FACTOR_IMAGE_FRESH..."
696     $COPY $FACTOR_IMAGE $FACTOR_IMAGE_FRESH
697 }
698
699 bootstrap() {
700     ./$FACTOR_BINARY -i=$BOOT_IMAGE
701     copy_fresh_image
702 }
703
704 install() {
705     check_factor_exists
706     get_config_info
707     git_clone
708     cd_factor
709     make_factor
710     set_boot_image_vars
711     get_boot_image
712     bootstrap
713 }
714
715 update() {
716     get_config_info
717     git_fetch
718     backup_factor
719     make_clean_factor
720 }
721
722 download_and_bootstrap() {
723     update_boot_image
724     bootstrap
725 }
726
727 net_bootstrap_no_pull() {
728     get_config_info
729     make_clean_factor
730     download_and_bootstrap
731 }
732
733 refresh_image() {
734     ./$FACTOR_BINARY -e="USING: vocabs.loader vocabs.refresh system memory ; refresh-all save 0 exit"
735     check_ret factor
736 }
737
738 make_boot_image() {
739     ./$FACTOR_BINARY -run="bootstrap.image" "$MAKE_IMAGE_TARGET"
740     check_ret factor
741 }
742
743 install_deps_apt() {
744     sudo apt install --yes libc6-dev libpango1.0-dev libx11-dev xorg-dev libgtk2.0-dev gtk2-engines-pixbuf libgtkglext1-dev wget git git-doc rlwrap clang make screen tmux libssl-dev
745     check_ret sudo
746 }
747
748 install_deps_pacman() {
749     sudo pacman --noconfirm -Syu gcc clang make rlwrap git wget pango glibc gtk2 gtk3 gtkglext gtk-engines gdk-pixbuf2 libx11 screen tmux
750     check_ret sudo
751 }
752
753 install_deps_dnf() {
754     sudo dnf --assumeyes install gcc gcc-c++ glibc-devel binutils libX11-devel pango-devel gtk3-devel gdk-pixbuf2-devel gtkglext-devel tmux rlwrap wget
755     check_ret sudo
756 }
757
758 install_deps_pkg() {
759     sudo pkg install --yes git gmake gcc rlwrap ripgrep curl gmake x11-toolkits/gtk30 x11-toolkits/gtkglext pango cairo vim
760 }
761
762
763 install_deps_macosx() {
764     test_program_installed git
765     if [[ $? -ne 1 ]] ; then
766         ensure_program_installed yes
767         $ECHO "git not found."
768         $ECHO "This script requires either git-core or port."
769         $ECHO "If it fails, install git-core or port and try again."
770         ensure_program_installed port
771         $ECHO "Installing git-core with port...this will take awhile."
772         yes | sudo port install git-core
773     fi
774 }
775
776 usage() {
777     $ECHO "usage: $0 command [optional-target]"
778     $ECHO "  install - git clone, compile, bootstrap"
779     $ECHO "  deps-apt - install required packages for Factor on Linux using apt"
780     $ECHO "  deps-pacman - install required packages for Factor on Linux using pacman"
781     $ECHO "  deps-dnf - install required packages for Factor on Linux using dnf"
782     $ECHO "  deps-pkg - install required packages for Factor on FreeBSD using pkg"
783     $ECHO "  deps-macosx - install git on MacOSX using port"
784     $ECHO "  self-update - git pull, recompile, make local boot image, bootstrap"
785     $ECHO "  quick-update - git pull, refresh-all, save"
786     $ECHO "  update|latest - git pull, recompile, download a boot image, bootstrap"
787     $ECHO "  compile - compile the binary"
788     $ECHO "  recompile - recompile the binary"
789     $ECHO "  bootstrap - bootstrap with existing boot image"
790     $ECHO "  net-bootstrap - recompile, download a boot image, bootstrap"
791     $ECHO "  make-target - find and print the os-arch-cpu string"
792     $ECHO "  report|info - print the build variables"
793     $ECHO "  update-boot-image - get the boot image for the current branch"
794     $ECHO ""
795     $ECHO "If you are behind a firewall, invoke as:"
796     $ECHO "env GIT_PROTOCOL=http $0 <command>"
797     $ECHO ""
798     $ECHO "Example for overriding the default target:"
799     $ECHO "    $0 update macosx-x86-32"
800 }
801
802 MAKE_TARGET=unknown
803
804 # -n is nonzero length, -z is zero length
805 if [[ -n "$2" ]] ; then
806     parse_build_info $2
807 fi
808
809 if [ "$#" -gt 3 ]; then
810     usage
811     $ECHO "error: too many arguments"
812     exit 1
813 fi
814
815
816 set_copy
817 set_delete
818
819 case "$1" in
820     install) install ;;
821     deps-apt) install_deps_apt ;;
822     deps-pacman) install_deps_pacman ;;
823     deps-macosx) install_deps_macosx ;;
824     deps-dnf) install_deps_dnf ;;
825     deps-pkg) install_deps_pkg ;;
826     self-bootstrap) get_config_info; make_boot_image; bootstrap;;
827     self-update) update; make_boot_image; bootstrap;;
828     quick-update) update; refresh_image ;;
829     update|latest) update; download_and_bootstrap ;;
830     compile) find_build_info; make_factor ;;
831     recompile) find_build_info; make_clean; make_factor ;;
832     bootstrap) get_config_info; bootstrap ;;
833     net-bootstrap) net_bootstrap_no_pull ;;
834     make-target) FIND_MAKE_TARGET=true; ECHO=false; find_build_info; exit_script ;;
835     report|info) find_build_info ;;
836     full-report) find_build_info; check_installed_programs; check_libraries ;;
837     update-boot-image) find_build_info; check_installed_programs; update_boot_image;;
838     *) usage ;;
839 esac
840